# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from unitycatalog.client.models.aws_iam_role_request import AwsIamRoleRequest
from unitycatalog.client.models.credential_purpose import CredentialPurpose
from typing import Optional, Set
from typing_extensions import Self

class CreateCredentialRequest(BaseModel):
    """
    CreateCredentialRequest
    """ # noqa: E501
    name: StrictStr = Field(description="The credential name. The name must be unique within the metastore.")
    comment: Optional[StrictStr] = Field(default=None, description="Comment associated with the credential.")
    aws_iam_role: Optional[AwsIamRoleRequest] = None
    purpose: Optional[CredentialPurpose] = None
    __properties: ClassVar[List[str]] = ["name", "comment", "aws_iam_role", "purpose"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateCredentialRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aws_iam_role
        if self.aws_iam_role:
            _dict['aws_iam_role'] = self.aws_iam_role.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateCredentialRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "comment": obj.get("comment"),
            "aws_iam_role": AwsIamRoleRequest.from_dict(obj["aws_iam_role"]) if obj.get("aws_iam_role") is not None else None,
            "purpose": obj.get("purpose")
        })
        return _obj


