# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from unitycatalog.client.models.aws_iam_role_response import AwsIamRoleResponse
from unitycatalog.client.models.credential_purpose import CredentialPurpose
from typing import Optional, Set
from typing_extensions import Self

class CredentialInfo(BaseModel):
    """
    CredentialInfo
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="The credential name. The name must be unique within the metastore.")
    aws_iam_role: Optional[AwsIamRoleResponse] = None
    comment: Optional[StrictStr] = Field(default=None, description="Comment associated with the credential.")
    owner: Optional[StrictStr] = Field(default=None, description="Username of current owner of credential.")
    full_name: Optional[StrictStr] = Field(default=None, description="The full name of the credential.")
    id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the credential.")
    created_at: Optional[StrictInt] = Field(default=None, description="Time at which this Credential was created, in epoch milliseconds.")
    created_by: Optional[StrictStr] = Field(default=None, description="Username of credential creator.")
    updated_at: Optional[StrictInt] = Field(default=None, description="Time at which this credential was last modified, in epoch milliseconds.")
    updated_by: Optional[StrictStr] = Field(default=None, description="Username of user who last modified the credential.")
    purpose: Optional[CredentialPurpose] = None
    __properties: ClassVar[List[str]] = ["name", "aws_iam_role", "comment", "owner", "full_name", "id", "created_at", "created_by", "updated_at", "updated_by", "purpose"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CredentialInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aws_iam_role
        if self.aws_iam_role:
            _dict['aws_iam_role'] = self.aws_iam_role.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CredentialInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "aws_iam_role": AwsIamRoleResponse.from_dict(obj["aws_iam_role"]) if obj.get("aws_iam_role") is not None else None,
            "comment": obj.get("comment"),
            "owner": obj.get("owner"),
            "full_name": obj.get("full_name"),
            "id": obj.get("id"),
            "created_at": obj.get("created_at"),
            "created_by": obj.get("created_by"),
            "updated_at": obj.get("updated_at"),
            "updated_by": obj.get("updated_by"),
            "purpose": obj.get("purpose")
        })
        return _obj


