# coding: utf-8

"""
    Unity Catalog API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ExternalLocationInfo(BaseModel):
    """
    ExternalLocationInfo
    """ # noqa: E501
    name: Optional[StrictStr] = Field(default=None, description="Name of the external location.")
    url: Optional[StrictStr] = Field(default=None, description="Path URL of the external location.")
    credential_name: Optional[StrictStr] = Field(default=None, description="Name of the storage credential used with this location.")
    comment: Optional[StrictStr] = Field(default=None, description="User-provided free-form text description.")
    owner: Optional[StrictStr] = Field(default=None, description="The owner of the external location.")
    credential_id: Optional[StrictStr] = Field(default=None, description="Unique ID of the location's storage credential.")
    created_at: Optional[StrictInt] = Field(default=None, description="Time at which this external location was created, in epoch milliseconds.")
    created_by: Optional[StrictStr] = Field(default=None, description="Username of external location creator.")
    updated_at: Optional[StrictInt] = Field(default=None, description="Time at which external location this was last modified, in epoch milliseconds.")
    updated_by: Optional[StrictStr] = Field(default=None, description="Username of user who last modified the external location.")
    __properties: ClassVar[List[str]] = ["name", "url", "credential_name", "comment", "owner", "credential_id", "created_at", "created_by", "updated_at", "updated_by"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExternalLocationInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExternalLocationInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": obj.get("name"),
            "url": obj.get("url"),
            "credential_name": obj.get("credential_name"),
            "comment": obj.get("comment"),
            "owner": obj.get("owner"),
            "credential_id": obj.get("credential_id"),
            "created_at": obj.get("created_at"),
            "created_by": obj.get("created_by"),
            "updated_at": obj.get("updated_at"),
            "updated_by": obj.get("updated_by")
        })
        return _obj


